
#property copyright "*"
#property link      "*"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 DodgerBlue
#property indicator_color2 Lime
#property indicator_color3 Yellow
#property indicator_color4 Red

#property indicator_maximum 7
#property indicator_minimum -7

//---- input parameters
extern bool Sh1=true;
extern bool Sh2=true;
extern bool Sh3=true;
extern bool Sh4=true;

extern double k1=1.0;
extern double k2=3.0;
extern double k3=6.0;
extern double k4=24.0;

extern int Pr=0;

//---- buffers

double A1[];
double A2[];
double A3[];
double A4[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE,0,4);
   SetIndexBuffer(0,A1);
   SetIndexStyle(1,DRAW_LINE,0,3);
   SetIndexBuffer(1,A2);
   
   SetIndexStyle(2,DRAW_LINE,0,2);
   SetIndexBuffer(2,A3);
   SetIndexStyle(3,DRAW_LINE,0,1);
   SetIndexBuffer(3,A4);  
   
   SetIndexLabel(0,"GMA Quadro 4");
   SetIndexLabel(1,"GMA Quadro 3"); 
   SetIndexLabel(2,"GMA Quadro 2");   
   SetIndexLabel(3,"GMA Quadro 1");   
   
   
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){
  double m;
  double c,p;
   int limit=Bars-IndicatorCounted();
      for(int i=limit-1;i>=0;i--){
         A4[i]=IndVal(k1,i);
         A3[i]=IndVal(k2,i);         
         A2[i]=IndVal(k3,i);         
         A1[i]=IndVal(k4,i);         
      }
   return(0);
  }
//+------------------------------------------------------------------+

double IndVal(double Koef,int Ind){
   double c=0;
   double m=0;
      m=iMACD(NULL,0,Koef*3,Koef*30,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;         
      m=iMACD(NULL,0,Koef*5,Koef*35,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;                    
      m=iMACD(NULL,0,Koef*8,Koef*40,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;          
      m=iMACD(NULL,0,Koef*10,Koef*45,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;   
      m=iMACD(NULL,0,Koef*12,Koef*50,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;
      m=iMACD(NULL,0,Koef*15,Koef*60,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;
   return(c);
}